observableAnswers(depth(K), A, E) :-
    copy_term(A, A1), oracle(depth(K), A1, E).

observableClause(depth(K), A, E, B, C) :-
    observableClause(subst, A, E1, B, C),
    K1 is K+2, depth(K1, E1, E).

domainBottom(depth(_K), Bottom) :- domainBottom(subst, Bottom).
    
domainProject(depth(_K), A, E, Esub) :- domainProject(subst, A, E, Esub).
    
domainMeet(depth(K), E, E1, EdepK) :-
    domainMeet(subst, E, E1, Esub),
    K1 is K+2, depth(K1, Esub, EdepK).

domainJoin(depth(_K), E, E1s, E2s) :- domainJoin(subst, E, E1s, E2s).

domainSingleton(depth(_K), E, E1) :- domainSingleton(subst, E, E1).

readObs(depth(K),A,EdepK) :- readObs(subst,A,Esub),K1 is K+1, depth(K1, Esub, EdepK).
showAelement(depth(K),A,E,Ae) :- showAelement(subst,A,E,Ae).

depth(0, _T, X):-!.
depth(K, T, T1) :-
    K>0, compound(T), !, functor(T,F,N),functor(T1,F,N), K1 is K-1, depth(N, K1, T, T1).
depth(K, T, T).

depth(0, _K, _, _).
depth(N, K, T, T1) :- 
    N >0, arg(N, T, A), depth(K, A, A1), arg(N, T1, A1), 
    N1 is N-1, depth(N1, K, T, T1).
