observableAnswers(subst, A, E) :-
    copy_term(A, A1), oracle(subst, A1, E).

observableClause(subst, A, E, B, C) :-
    copy_term(A,A2), clause(A2,B2), freecopy(B2,B),
    E = (A2:-B2), copy_term(E,C).

domainBottom(subst, emptyset).

domainMeet(subst, E, E1, (A1 :- Bs)) :-
    copy_term(E,(A1:-(B1,Bs))), B1 = E1.
domainMeet(subst, E, E1, (A1 :- true)) :-
    copy_term(E,(A1:-B1)), B1 = E1.

domainProject(subst, _A, (A1:- _), A1).

domainJoin(subst, emptyset,Xs,Xs) :- !.
domainJoin(subst, Xs,emptyset,Xs) :- !.
domainJoin(subst, Xs,Ys,Xs).
domainJoin(subst, Xs,Ys,Ys).

domainSingleton(subst,E,Es) :- var(E), E=Es.
domainSingleton(subst,E,Es) :- nonvar(E), variant(E,Es).

readObs(subst,A,E) :- read(E).
showAelement(subst,A,E,E).

freecopy((A,As),(B,Bs)) :- 
    !, freecopy(As,Bs), functor(A,F,N), functor(B,F,N).
freecopy(A,B) :- !,functor(A,F,N), functor(B,F,N).

variant(T1,T2) :-
    copy_term(T2,T3),
    not not ( (numbervars(T1,0,N), numbervars(T3,0,N), T1 = T3) ).
